#ifndef __CMIOS9_IDENT_H
#define __CMIOS9_IDENT_H
/*
* Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008  K. M. Indlekofer
*
* m.indlekofer@gmx.de
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



/* OS-9 Level 2 (OS-9/6809) */

/* general header */
struct modhead_s{
#define M_MODSYNC 0x87cd
	u_char m_ID[2];
	u_char m_Size[2];
	u_char m_Name[2];
	u_char m_TyLa;
	u_char m_AtRv;
#define M_PARITYLEN sizeof(struct modhead_s)
	u_char m_Parity;
};
#define MODNAMELEN 32 /* XXX */

#define M_TYPE_GENERIC 0
#define M_TYPE_PROG    1
#define M_TYPE_SUBR    2
#define M_TYPE_MULTI   3
#define M_TYPE_DATA    4
#define M_TYPE_DATARAM 5
#define M_TYPE_PPROG   6 /* USR6 */
#define M_TYPE_VPROG   7 /* USR7 */
#define M_TYPE_USR8    8
#define M_TYPE_USR9    9
#define M_TYPE_USRA    10
#define M_TYPE_USRB    11
#define M_TYPE_SYSTEM  12
#define M_TYPE_FILEMAN 13
#define M_TYPE_DEVDVR  14
#define M_TYPE_DEVDSC  15

extern char *(m_Type_Name[]);

#define M_LANG_DATA          0
#define M_LANG_6809OBJ       1
#define M_LANG_BASIC09_ICODE 2
#define M_LANG_PASCAL_PCODE  3
#define M_LANG_C_ICODE       4
#define M_LANG_COBOL_ICODE   5
#define M_LANG_FORTRAN_ICODE 6
#define M_LANGMAX            6

extern char *(m_Lang_Name[]);

#define M_ATTR_REENT  8
#define M_ATTR_WRTEN  4
#define M_ATTR_CHKCRC 2
#define M_ATTR_ANON   1

/* additional header data */

/* executable module */
struct modhead_exec_s{
	u_char m_ExecOff[2];
	u_char m_DataSize[2];
};

/* device descriptor */
struct modhead_devdsc_s{
	u_char m_FmName[2];
	u_char m_DdName[2];
	u_char m_Mode;
};
/* followup if non-alias device: */
struct modhead_devdsc2_s{
	u_char m_Control[3]; /* controller address */
	u_char m_TabSize;    /* option table size */
};

/* configuration module */
struct modhead_conf_s{
	u_char m_RAMTop[3];
	u_char m_IRQNo;
	u_char m_DevNo;
	u_char m_Startup[2];
	u_char m_SysDrive[2];
	u_char m_Boot[2];
};

/* C data */
struct modhead_cdata_s{
	u_char m_Data[2];
	u_char m_DSize[2];
};



/* OS-9 (OS-9/6809) bootstrap conditional */

/* general header */
struct modheadb_s{
#define MB_MODSYNC 0x8fc7
	u_char m_ID[2];
	u_char m_Type;
	u_char m_Size; /* number of following bytes */
};



/* OSK (OS-9/68K) */

/* general header */
struct modheadk_s{
#define MK_MODSYNC 0x4afc /* same as OS-9000/68K! */
	u_char m_ID[2];
	u_char m_SysRev[2];
	u_char m_Size[4];
	u_char m_Owner[4];
	u_char m_Name[4];
	u_char m_Accs[2];
	u_char m_Type;
	u_char m_Lang;
	u_char m_Attr;
	u_char m_Revs;
	u_char m_Edit[2];
	u_char m_Reserved[22];
#define MK_PARITYLEN sizeof(struct modheadk_s)
	u_char m_Parity[2];
};

/* general header for old OSK */
struct modheadoldk_s{
#define MOLDK_MODSYNC 0x4afc /* same as OS-9/68K! */
	u_char m_ID[2];
	u_char m_Size[4];
	u_char m_Owner[2];
	u_char m_Name[4];
	u_char m_Accs[2];
	u_char m_Type;
	u_char m_Lang;
	u_char m_Attr;
	u_char m_Revs;
	u_char m_Edit[2];
#define MOLDK_PARITYLEN sizeof(struct modheadoldk_s)
	u_char m_Parity[2];
};

#define MK_ACCS_OWNER_READ   0x0001
#define MK_ACCS_OWNER_WRITE  0x0002
#define MK_ACCS_OWNER_EXEC   0x0004
#define MK_ACCS_GROUP_READ   0x0010
#define MK_ACCS_GROUP_WRITE  0x0020
#define MK_ACCS_GROUP_EXEC   0x0040
#define MK_ACCS_WORLD_READ   0x0100
#define MK_ACCS_WORLD_WRITE  0x0200
#define MK_ACCS_WORLD_EXEC   0x0400

#define MK_TYPE_GENERIC 0
#define MK_TYPE_PROG    1
#define MK_TYPE_SUBR    2
#define MK_TYPE_MULTI   3
#define MK_TYPE_DATA    4
#define MK_TYPE_CSDData 5
#define MK_TYPE_TRAPLIB 11
#define MK_TYPE_SYSTEM  12
#define MK_TYPE_FILEMAN 13
#define MK_TYPE_DEVDVR  14
#define MK_TYPE_DEVDSC  15
#define MK_TYPEMAX      15

extern char *(mk_Type_Name[]);

#define MK_LANG_UNSPECIFIED   0
#define MK_LANG_68KOBJ        1
#define MK_LANG_BASIC_ICODE   2
#define MK_LANG_PASCAL_PCODE  3
#define MK_LANG_C_ICODE       4
#define MK_LANG_COBOL_ICODE   5
#define MK_LANG_FORTRAN_ICODE 6
#define MK_LANGMAX            15

extern char *(mk_Lang_Name[]);

#define MOLDK_ATTR_REENT  0x80
#define MOLDK_ATTR_GHOST  0x40
#define MOLDK_ATTR_SUPER  0x20

/* additional header data */

/* executable module */
struct modheadk_exec_s{
	u_char m_ExecOff[4];
	u_char m_Excpt[4];
	u_char m_Data[4];
	u_char m_Stack[4];
	u_char m_IData[4];
	u_char m_IDRef[4];
};

/* device driver */
struct modheadk_devdrv_s{
	u_char m_Exec[4];
	u_char m_Excpt[4];
	u_char m_Data[4];
	u_char m_DInit[2];
	u_char m_DWrite[2];
	u_char m_DGetStat[2];
	u_char m_DSetSTT[2];
	u_char m_DTerm[2];
	u_char m_DError[2];
};

/* device descriptor */
struct modheadk_devdsc_s{
	u_char m_Port[4];
	u_char m_Vector;
	u_char m_IRQlvl;
	u_char m_Priority;
	u_char m_Mode;
	u_char m_FMgr[2];
	u_char m_PDev[2];
	u_char m_DevCon[2];
	u_char m_res[8];
	u_char m_Opt[2];
	u_char m_DType[2];
};

/* configuration module */
struct modheadk_conf_s{
	u_char m_MaxMem[4];
	u_char m_PollSz[2];
	u_char m_DevCnt[2];
	u_char m_Procs[2];
	u_char m_Paths[2];
	u_char m_IOMan[2];
	u_char m_SysGo[2];
	u_char m_SysDrive[2];
	u_char m_Consol[2];
	u_char m_Extens[2];
	u_char m_Clock[2];
	u_char m_Slice[2];
	u_char m_UsrAct[2];
	u_char m_Site[4];
	u_char m_Instal[2];
	u_char m_CPUtyp[4];
	u_char m_OS9lvl[4];
	u_char m_OS9rev[2];
	u_char m_SysPri[2];
	u_char m_MinPty[2];
	u_char m_MaxAge[2];
	u_char m_MDirSz[2];
	u_char m_res[28];
};



/* OS-9000 */
/* general header */
/* revision-independent header: */
struct modhead9k_s{
#define M9K_68K_MODSYNC     0x4afc /* XXX same as OS-9/68K! */
#define M9K_386_MODSYNC     0x4afd /* XXX */
#define M9K_POWERPC_MODSYNC 0xf00d
#define M9K_CMX_MODSYNC     0x0d4c
#define M9K_ARM_MODSYNC     0xff6a
#define M9K_MIPS_MODSYNC    0x4dad
#define M9K_SH3_MODSYNC     0x09a9
#define M9K_SH4_MODSYNC     0x0591
#define M9K_SPARC_MODSYNC   0x812a
	u_char m_ID[2];
	u_char m_SysRev[2];
	u_char m_Size[4];
	u_char m_Owner[4];
	u_char m_Name[4];
	u_char m_Accs[2];
	u_char m_Type;
	u_char m_Lang;
	u_char m_Attr;
	u_char m_Revs;
	u_char m_Edit[2];
	u_char m_Needs[4];
	u_char m_Share[4];
	u_char m_Symbol[4];
	u_char m_Exec[4];
	u_char m_Excpt[4];
	u_char m_Data[4];
	u_char m_Stack[4];
	u_char m_IData[4];
	u_char m_IDRef[4];
	u_char m_Init[4];
	u_char m_Term[4];
	u_char m_DBias[4];
	u_char m_CBias[4];
	u_char m_Ident[2];
	u_char m_spare[8];
#define M9K_PARITYLEN sizeof(struct modhead9k_s)
	u_char m_Parity[2];
};

#define M9K_TYPE_GENERIC 0
#define M9K_TYPE_PROG    1
#define M9K_TYPE_SUBR    2
#define M9K_TYPE_MULTI   3
#define M9K_TYPE_DATA    4
#define M9K_TYPE_CDBDATA 5
#define M9K_TYPE_TRAPLIB 11
#define M9K_TYPE_SYSTEM  12
#define M9K_TYPE_FILEMAN 13
#define M9K_TYPE_DEVDVR  14
#define M9K_TYPE_DEVDSC  15
#define M9K_TYPEMAX      15

extern char *(m9k_Type_Name[]);

#define M9K_LANG_UNSPECIFIED   0
#define M9K_LANG_OBJECT        1
#define M9K_LANG_ICODE         2
#define M9K_LANG_PCODE         3
#define M9K_LANG_CCODE         4
#define M9K_LANG_CBLCODE       5
#define M9K_LANG_FRTNCODE      6
#define M9K_LANGMAX            15

extern char *(m9k_Lang_Name[]);



/* CRC */

#define CRCCON  0x00800fe3 /* OS-9-module CRC check result */
#define CRCCONJ 0x00000000 /* OSK J-module CRC check result */

extern int crccheck(u_int init,u_char *word,int wordlen);
extern int crcgen(u_char *word, int wordlen,int jmod);



extern int printident(char *path,int ignore,u_int start);



#endif /* !__CMIOS9_IDENT_H */
